#include "main.h"

unsigned char CS8422_buf[ALL_REGISTERS] = {0};

unsigned char CS8422_ReadByte(unsigned char addr)
{
	unsigned char rx = 0;

	// Select Register
	SPI_nSS_PORT_REG &= ~(1 << SPI_nSS_PIN);
	SPI_SendByte(CS8422_ADDR);
	SPI_SendByte(addr);
	SPI_nSS_PORT_REG |= (1 << SPI_nSS_PIN);

	// Read Register
	SPI_nSS_PORT_REG &= ~(1 << SPI_nSS_PIN);
	SPI_SendByte(CS8422_ADDR | RD_MARKER);
	rx = SPI_SendByte(0x00);
	SPI_nSS_PORT_REG |= (1 << SPI_nSS_PIN);

	return rx;
}

void CS8422_ReadBlock(unsigned char start_addr, unsigned char count)
{
	// Select Register
	SPI_nSS_PORT_REG &= ~(1 << SPI_nSS_PIN);
	SPI_SendByte(CS8422_ADDR);
	SPI_SendByte(start_addr | INC_MARKER);
	SPI_nSS_PORT_REG |= (1 << SPI_nSS_PIN);

	SPI_nSS_PORT_REG &= ~(1 << SPI_nSS_PIN);
	SPI_SendByte(CS8422_ADDR | RD_MARKER);

	for (unsigned char i = 0; i < count; i++)
	{
		CS8422_buf[i + start_addr - 1] = SPI_SendByte(0x00);
	}
	SPI_nSS_PORT_REG |= (1 << SPI_nSS_PIN);
}

void CS8422_WriteByte(unsigned char addr, unsigned char value)
{
	// Select & Write Register
	SPI_nSS_PORT_REG &= ~(1 << SPI_nSS_PIN);
	SPI_SendByte(CS8422_ADDR);
	SPI_SendByte(addr);
	SPI_SendByte(value);
	SPI_nSS_PORT_REG |= (1 << SPI_nSS_PIN);
}

void CS8422_WriteBlock(unsigned char* src, unsigned char start_addr, unsigned char count)
{
	// Select & Write Register
	SPI_nSS_PORT_REG &= ~(1 << SPI_nSS_PIN);
	SPI_SendByte(CS8422_ADDR);
	SPI_SendByte(start_addr | INC_MARKER);

	for (unsigned char i = 0; i < count; i++)
	{
		SPI_SendByte(src[i]);
	}

	SPI_nSS_PORT_REG |= (1 << SPI_nSS_PIN);
}