#ifndef CS8422_H_
#define CS8422_H_

#define CS8422_ADDR						0x20
#define RD_MARKER						0x01
#define INC_MARKER						0x80
#define ALL_REGISTERS					48

// CS8422 Register map
#define REG_01_CHIP_ID_VER				0x01
#define REG_02_CLK_CTRL					0x02
#define REG_03_RESEIVER_INPUT_CTRL		0x03
#define REG_04_RESEIVER_DATA_CTRL		0x04
#define REG_05_GPO_CTRL_1				0x05
#define REG_06_GPO_CTRL_2				0x06
#define REG_07_SAI_CLK_CTRL				0x07
#define REG_08_SRC_SAO_CLK_CTRL			0x08
#define REG_09_RMCK_RATIO_CTRL_MISC		0x09
#define REG_0A_DATA_ROUTING_CTRL		0x0A
#define REG_0B_SAI_DATA_FMT				0x0B
#define REG_0C_SAO_1_DATA_FMT			0x0C
#define REG_0D_SAO_2_DATA_FMT			0x0D
#define REG_0E_RERR_UNMASK				0x0E
#define REG_0F_INT_UNMASK				0x0F
#define REG_10_INT_MODE					0x10
#define REG_11_RESEIVER_CH_STATUS		0x11
#define REG_12_FMT_DETECT_STATUS		0x12
#define REG_13_RECEIVER_ERROR			0x13
#define REG_14_INT_STATUS				0x14
#define REG_15_PLL_STATUS				0x15
#define REG_16_RECEIVER_STATUS			0x16
#define REG_17_FS_XTI_RATIO_1			0x17
#define REG_18_FS_XTI_RATIO_2			0x18
#define REG_19_Q_SUBCODE_1				0x19
#define REG_1A_Q_SUBCODE_2				0x1A
#define REG_1B_Q_SUBCODE_3				0x1B
#define REG_1C_Q_SUBCODE_4				0x1C
#define REG_1D_Q_SUBCODE_5				0x1D
#define REG_1E_Q_SUBCODE_6				0x1E
#define REG_1F_Q_SUBCODE_7				0x1F
#define REG_20_Q_SUBCODE_8				0x20
#define REG_21_Q_SUBCODE_9				0x21
#define REG_22_Q_SUBCODE_10				0x22
#define REG_23_CH_A_STATUS_BYTE_0		0x23
#define REG_24_CH_A_STATUS_BYTE_1		0x24
#define REG_25_CH_A_STATUS_BYTE_2		0x25
#define REG_26_CH_A_STATUS_BYTE_3		0x26
#define REG_27_CH_A_STATUS_BYTE_4		0x27
#define REG_28_CH_B_STATUS_BYTE_0		0x28
#define REG_29_CH_B_STATUS_BYTE_1		0x29
#define REG_2A_CH_B_STATUS_BYTE_2		0x2A
#define REG_2B_CH_B_STATUS_BYTE_3		0x2B
#define REG_2C_CH_B_STATUS_BYTE_4		0x2C
#define REG_2D_BURST_PREA_PC_BYTE_0		0x2D
#define REG_2E_BURST_PREA_PC_BYTE_1		0x2E
#define REG_2F_BURST_PREA_PD_BYTE_0		0x2F
#define REG_30_BURST_PREA_PD_BYTE_1		0x30

extern unsigned char CS8422_buf[ALL_REGISTERS];

void CS8422_ReadBlock(unsigned char start_addr, unsigned char count);
void CS8422_WriteBlock(unsigned char* src, unsigned char start_addr, unsigned char count);

#endif /* CS8422_H_ */