#ifndef MAIN_H_
#define MAIN_H_

#include <avr/io.h>
#include <avr/interrupt.h>

// System constants
#define F_CPU 8000000UL
#define BAUDRATE 9600

#include "spi.h"
#include "uart.h"
#include "cs8422.h"

// SPI
#define SPI_SCK_DDR_REG		DDRB
#define SPI_SCK_PORT_REG	PORTB
#define SPI_SCK_PIN_REG		PINB
#define SPI_SCK_PIN			PORTB5

#define SPI_MOSI_DDR_REG	DDRB
#define SPI_MOSI_PORT_REG	PORTB
#define SPI_MOSI_PIN_REG	PINB
#define SPI_MOSI_PIN		PORTB3

#define SPI_MISO_DDR_REG	DDRB
#define SPI_MISO_PORT_REG	PORTB
#define SPI_MISO_PIN_REG	PINB
#define SPI_MISO_PIN		PORTB4

#define SPI_nSS_DDR_REG		DDRB
#define SPI_nSS_PORT_REG	PORTB
#define SPI_nSS_PIN_REG		PINB
#define SPI_nSS_PIN			PORTB2

#define UART_TX_DDR_REG		DDRD
#define UART_TX_PORT_REG	PORTD
#define UART_TX_PIN_REG		PIND
#define UART_TX_PIN			PORTD1

#define UART_RX_DDR_REG		DDRD
#define UART_RX_PORT_REG	PORTD
#define UART_RX_PIN_REG		PIND
#define UART_RX_PIN			PORTD0

#endif /* MAIN_H_ */