#include "spi.h"

void SPI_Init(void)
{
	// SPI GPIO Init
	SPI_SCK_DDR_REG |= (1 << SPI_SCK_PIN);
	SPI_MOSI_DDR_REG |= (1 << SPI_MOSI_PIN);
	SPI_MISO_DDR_REG &= ~(1 << SPI_MISO_PIN);
	SPI_nSS_DDR_REG |= (1 << SPI_nSS_PIN); //    nSS  

	SPI_SCK_PORT_REG |= (1 << SPI_SCK_PIN);
	SPI_MOSI_PORT_REG |= (1 << SPI_MOSI_PIN);
	SPI_nSS_PORT_REG |= (1 << SPI_nSS_PIN);

	SPCR = (1 << SPE) | (1 << MSTR) | (1 << SPI2X);
}

void SPI_Latch(volatile unsigned char * REG, unsigned char PIN)
{
	*REG |=  (1 << PIN);
	*REG &= ~(1 << PIN);
}

unsigned char SPI_SendByte(unsigned char byte)
{
	SPDR = byte;
	while(!(SPSR & (1 << SPIF)));
	return SPDR;
}

void SPI_SendNBytes(unsigned char* arr, unsigned char length)
{
	for (unsigned char i = 0; i < length; i++)
	{
		RX_buf[i] = SPI_SendByte(arr[i]);
	}
}
