#include "uart.h"

void UART_Init(unsigned long int baudrate)
{
	//UART_TX_DDR_REG |= (1 << UART_TX_PIN);
	//UART_RX_DDR_REG &= ~(1 << UART_RX_PIN);

	//UART_TX_DDR_REG &= ~(1 << UART_TX_PIN);

	UBRR0H = (unsigned char)((F_CPU / 16 / baudrate - 1) >> 8);
	UBRR0L = (unsigned char)(F_CPU / 16 / baudrate - 1);
	UCSR0B = (1 << RXEN0) | (1 << TXEN0) | (1 << RXCIE0);
	UCSR0C = (1 << UCSZ01) | (1 << UCSZ00);
}

static void UART_SendByte(unsigned char data)
{
	while (!(UCSR0A & (1<<UDRE0)));
	UDR0 = data;
}

void UART_SendString(char* str)
{
	for(unsigned int i = 0; (str[i] != '\0'); i++)
	{
		UART_SendByte(str[i]);
	}
}

void UART_printf(const char *args, ...)
{
	char StrBuff[64];

	va_list ap;
	va_start(ap, args);
	vsnprintf(StrBuff, sizeof(StrBuff), args, ap);
	va_end(ap);

	UART_SendString(StrBuff);
}